<template>
    <QuillEditor
        :id="idInput"
        ref="editor"
        :options="options"
        @update:content="onUpdateContent"
    />
</template>

<script>
import { onMounted, reactive, ref } from "vue";
import { Quill, QuillEditor } from "@vueup/vue-quill";
import "@vueup/vue-quill/dist/vue-quill.snow.css";

let AlignClass = Quill.import("attributors/style/align");
Quill.register(AlignClass, true);

export default {
    components: {
        QuillEditor
    },
    props: {
        content: {
            type: String,
            required: true
        },
        readOnly: {
            type: Boolean,
            default: false
        },
        idInput: {
            type: String,
            default: ""
        },
        height: {
            type: String,
            default: "300"
        },
        placeholder: {
            type: String,
            default: "Nhập nội dung vào đây..."
        }
    },
    setup(props, context) {
        const editor = ref(null);
        const options = reactive({
            modules: {
                toolbar: [
                    [{ header: [1, 2, 3, 4, 5, 6, false] }],
                    ["bold", "italic", "underline", "strike"],
                    ["blockquote", "code-block"],
                    [{ list: "ordered" }, { list: "bullet" }],
                    [{ script: "sub" }, { script: "super" }],
                    [{ indent: "-1" }, { indent: "+1" }],
                    [{ direction: "rtl" }],
                    [{ color: [] }, { background: [] }],
                    [{ align: [] }],
                    ["link", "image", "video"],
                    ["clean"]
                ]
            },
            placeholder: props.placeholder,
            readOnly: props.readOnly,
            theme: "snow"
        });

        onMounted(() => {
            if (editor.value && editor.value.setHTML) {
                editor.value.setHTML(props.content);
            }

            const style = document.createElement("style");
            style.innerHTML = `${
                props.idInput ? "#" + props.idInput : ""
            }.ql-container {height: ${props.height}px;}`;
            document.querySelector("body").appendChild(style);
        });

        function onUpdateContent() {
            const newHtml = editor.value.getHTML();
            context.emit("update:content", newHtml);
        }

        return {
            editor,
            options,
            onUpdateContent
        };
    }
};
</script>

<style lang="scss">
// .ql-container {
//   height: 300px;
// }
div[data-mode="link"],
div[data-mode="video"] {
    z-index: 99999;
}
.ql-disabled {
    background-color: #efefef4d;
}
</style>
